{:Define la clase del thread para trabajar con sentencias SQL atravs de ADO
@author Germn Estvez
        http://neftali.clubdelphi.com
        german_ral@hotmail.com
}

unit UADOSQLThread;
{=========================================================================

  Unit

  Propsito : Define la clase derivada de TThread

========================================================================
  Historia de las Versiones
------------------------------------------------------------------------

  * Creacin: 27/07/2010
------------------------------------------------------------------------
   ...

=========================================================================

  Errores detectados no corregidos

=========================================================================}


//=========================================================================
//
// I N T E R F A C E
//
//=========================================================================
interface

uses
  Classes, ADODB, SysUtils;

type
  TADOSQLThread = class(TThread)
  private
    FADOQ: TADOQuery;
    FSQL: string;
    FTotalTime:string;
  public
    constructor Create(CreateSuspended:Boolean; AConnString:String;
                       ASQL:string);
    destructor Destroy; override;
    procedure Execute(); override;
    property SQL:string read FSQL write FSQL;
    property ADOQ:TADOQuery read FADOQ write FADOQ;
    property TotalTime:string read FTotalTime;
  end;




//=========================================================================
//
// I M P L E M E N T A T I O N
//
//=========================================================================
implementation


constructor TADOSQLThread.Create(CreateSuspended:Boolean; AConnString:String;
                                 ASQL:string);
begin

  inherited Create(CreateSuspended);

  // ini
  Self.FreeOnTerminate := True;

  //crea el query   mssql   busca extensiones
  FADOQ := TADOQuery.Create(nil);
  FADOQ.ConnectionString := AConnString;
  FADOQ.SQL.Add(ASQL);
  Self.FSQL:= ASQL;
end;

destructor TADOSQLThread.Destroy();
begin

// Al cerrar el form
//  // Cerrar
//  Self.FADOQ.Close();
//  // LIberar
//  FreeAndNil(Self.FADOQ);

  inherited;
end;


procedure TADOSQLThread.Execute();
var
  _ini,_fin:Double; // tiempo total
begin

  inherited;

  _ini := now;
  // Ejecutar la consulta
  Self.FADOQ.Open;
  _fin := now;

  FTotalTime := FormatDateTime('nn:ss:zzz', _fin-_ini);

end;

end.
